Index: /branches/UKMO/dev_r5518_GO6_fix_cpp_keys/NEMOGCM/NEMO/TOP_SRC/MEDUSA/air_sea.F90
===================================================================
--- /branches/UKMO/dev_r5518_GO6_fix_cpp_keys/NEMOGCM/NEMO/TOP_SRC/MEDUSA/air_sea.F90	(revision 10006)
+++ /branches/UKMO/dev_r5518_GO6_fix_cpp_keys/NEMOGCM/NEMO/TOP_SRC/MEDUSA/air_sea.F90	(revision 10007)
@@ -63,4 +63,7 @@
                                    zchd, zchn, zdin, zsil
       USE dom_oce,           ONLY: e3t_0, gphit, tmask, mig, mjg
+# if defined key_vvl
+      USE dom_oce,           ONLY: e3t_n
+# endif
       USE iom,               ONLY: lk_iomput
       USE in_out_manager,    ONLY: lwp, numout
Index: /branches/UKMO/dev_r5518_GO6_fix_cpp_keys/NEMOGCM/NEMO/TOP_SRC/MEDUSA/bio_med_diag_iomput.F90
===================================================================
--- /branches/UKMO/dev_r5518_GO6_fix_cpp_keys/NEMOGCM/NEMO/TOP_SRC/MEDUSA/bio_med_diag_iomput.F90	(revision 10006)
+++ /branches/UKMO/dev_r5518_GO6_fix_cpp_keys/NEMOGCM/NEMO/TOP_SRC/MEDUSA/bio_med_diag_iomput.F90	(revision 10007)
@@ -32,4 +32,7 @@
       USE bio_medusa_mod
       USE dom_oce,           ONLY: e3t_0, mbathy, tmask
+# if defined key_vvl
+      USE dom_oce,           ONLY: e3t_n
+# endif
       USE in_out_manager,    ONLY: lwp, numout
       USE par_oce,           ONLY: jpim1, jpjm1
Index: /branches/UKMO/dev_r5518_GO6_fix_cpp_keys/NEMOGCM/NEMO/TOP_SRC/MEDUSA/bio_medusa_diag.F90
===================================================================
--- /branches/UKMO/dev_r5518_GO6_fix_cpp_keys/NEMOGCM/NEMO/TOP_SRC/MEDUSA/bio_medusa_diag.F90	(revision 10006)
+++ /branches/UKMO/dev_r5518_GO6_fix_cpp_keys/NEMOGCM/NEMO/TOP_SRC/MEDUSA/bio_medusa_diag.F90	(revision 10007)
@@ -33,4 +33,7 @@
       USE bio_medusa_mod
       USE dom_oce,                  ONLY: e3t_0, gdepw_0, tmask
+# if defined key_vvl
+      USE dom_oce,                  ONLY: e3t_n, gdepw_n
+# endif
       USE in_out_manager,           ONLY: lwp, numout
       USE iom,                      ONLY: lk_iomput
Index: /branches/UKMO/dev_r5518_GO6_fix_cpp_keys/NEMOGCM/NEMO/TOP_SRC/MEDUSA/bio_medusa_update.F90
===================================================================
--- /branches/UKMO/dev_r5518_GO6_fix_cpp_keys/NEMOGCM/NEMO/TOP_SRC/MEDUSA/bio_medusa_update.F90	(revision 10006)
+++ /branches/UKMO/dev_r5518_GO6_fix_cpp_keys/NEMOGCM/NEMO/TOP_SRC/MEDUSA/bio_medusa_update.F90	(revision 10007)
@@ -72,4 +72,7 @@
                                    zpds, zphd, zphn
       USE dom_oce,           ONLY: e3t_0, gphit, mbathy, tmask
+# if defined key_vvl
+      USE dom_oce,           ONLY: e3t_n
+# endif
       USE in_out_manager,    ONLY: lwp, numout
       USE lib_mpp,           ONLY: ctl_stop
Index: /branches/UKMO/dev_r5518_GO6_fix_cpp_keys/NEMOGCM/NEMO/TOP_SRC/MEDUSA/carb_chem.F90
===================================================================
--- /branches/UKMO/dev_r5518_GO6_fix_cpp_keys/NEMOGCM/NEMO/TOP_SRC/MEDUSA/carb_chem.F90	(revision 10006)
+++ /branches/UKMO/dev_r5518_GO6_fix_cpp_keys/NEMOGCM/NEMO/TOP_SRC/MEDUSA/carb_chem.F90	(revision 10007)
@@ -41,4 +41,7 @@
                                    zalk, zdic, zsal, zsil, ztmp 
       USE dom_oce,           ONLY: gdept_0, gdepw_0, gphit, mbathy, tmask
+# if defined key_vvl
+      USE dom_oce,           ONLY: gdept_n, gdepw_n
+# endif
       USE in_out_manager,    ONLY: lwp, numout
       USE oce,               ONLY: PCO2a_in_cpl, tsb, tsn
Index: /branches/UKMO/dev_r5518_GO6_fix_cpp_keys/NEMOGCM/NEMO/TOP_SRC/MEDUSA/detritus.F90
===================================================================
--- /branches/UKMO/dev_r5518_GO6_fix_cpp_keys/NEMOGCM/NEMO/TOP_SRC/MEDUSA/detritus.F90	(revision 10006)
+++ /branches/UKMO/dev_r5518_GO6_fix_cpp_keys/NEMOGCM/NEMO/TOP_SRC/MEDUSA/detritus.F90	(revision 10007)
@@ -46,4 +46,7 @@
       USE detritus_fast_sink_mod, ONLY: detritus_fast_sink
       USE dom_oce,                ONLY: mbathy, e3t_0, gphit, tmask
+# if defined key_vvl
+      USE dom_oce,                ONLY: e3t_n
+# endif
       USE in_out_manager,         ONLY: lwp, numout
       USE par_oce,                ONLY: jpim1, jpjm1
Index: /branches/UKMO/dev_r5518_GO6_fix_cpp_keys/NEMOGCM/NEMO/TOP_SRC/MEDUSA/detritus_fast_sink.F90
===================================================================
--- /branches/UKMO/dev_r5518_GO6_fix_cpp_keys/NEMOGCM/NEMO/TOP_SRC/MEDUSA/detritus_fast_sink.F90	(revision 10006)
+++ /branches/UKMO/dev_r5518_GO6_fix_cpp_keys/NEMOGCM/NEMO/TOP_SRC/MEDUSA/detritus_fast_sink.F90	(revision 10007)
@@ -67,4 +67,7 @@
                                    zdet, zdtc
       USE dom_oce,           ONLY: e3t_0, gdepw_0, gphit, mbathy, tmask
+# if defined key_vvl
+      USE dom_oce,           ONLY: e3t_n, gdepw_n
+# endif
       USE in_out_manager,    ONLY: lwp, numout
       USE oce,               ONLY: tsn
Index: /branches/UKMO/dev_r5518_GO6_fix_cpp_keys/NEMOGCM/NEMO/TOP_SRC/MEDUSA/iron_chem_scav.F90
===================================================================
--- /branches/UKMO/dev_r5518_GO6_fix_cpp_keys/NEMOGCM/NEMO/TOP_SRC/MEDUSA/iron_chem_scav.F90	(revision 10006)
+++ /branches/UKMO/dev_r5518_GO6_fix_cpp_keys/NEMOGCM/NEMO/TOP_SRC/MEDUSA/iron_chem_scav.F90	(revision 10007)
@@ -36,4 +36,7 @@
                                    idf, idfval                          
       USE dom_oce,           ONLY: e3t_0, gdepw_0, mbathy, tmask
+#if defined key_vvl
+      USE dom_oce,           ONLY: e3t_n, gdepw_n
+#endif
       USE par_kind,          ONLY: wp
       USE in_out_manager,    ONLY: lwp, numout
Index: /branches/UKMO/dev_r5518_GO6_fix_cpp_keys/NEMOGCM/NEMO/TOP_SRC/MEDUSA/phytoplankton.F90
===================================================================
--- /branches/UKMO/dev_r5518_GO6_fix_cpp_keys/NEMOGCM/NEMO/TOP_SRC/MEDUSA/phytoplankton.F90	(revision 10006)
+++ /branches/UKMO/dev_r5518_GO6_fix_cpp_keys/NEMOGCM/NEMO/TOP_SRC/MEDUSA/phytoplankton.F90	(revision 10007)
@@ -45,4 +45,7 @@
                                    zzme, zzmi, fchl_ml
       USE dom_oce,           ONLY: e3t_0, gdepw_0, tmask
+#if defined key_vvl
+      USE dom_oce,           ONLY: e3t_n, gdepw_n
+#endif
       USE in_out_manager,    ONLY: lwp, numout
       USE oce,               ONLY: tsn
Index: /branches/UKMO/dev_r5518_GO6_fix_cpp_keys/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcbio_medusa.F90
===================================================================
--- /branches/UKMO/dev_r5518_GO6_fix_cpp_keys/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcbio_medusa.F90	(revision 10006)
+++ /branches/UKMO/dev_r5518_GO6_fix_cpp_keys/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcbio_medusa.F90	(revision 10007)
@@ -78,12 +78,14 @@
                                             zfer, zpds, zphd, zphn, zsil,   &
                                             zzme, zzmi
-      USE dom_oce,                    ONLY: e3t_0,                          &
-                                            gdept_0,                        &
-                                            gdepw_0,                        &
-                                            nday_year, nsec_day,            &
+      USE dom_oce,                    ONLY: e3t_0, gdept_0,  gdepw_0,       &
+                                            nday_year, nsec_day,            & 
                                             nyear, nyear_len, ndastp,       &
                                             nsec_month,                     &
                                             rdt, tmask, mig, mjg, nimpp,    &
                                             njmpp 
+#if defined key_vvl
+      USE dom_oce,                    ONLY: e3t_n, gdept_n,  gdepw_n
+#endif
+
       USE in_out_manager,             ONLY: lwp, numout, nn_date0
       USE iom,                        ONLY: lk_iomput
Index: /branches/UKMO/dev_r5518_GO6_fix_cpp_keys/NEMOGCM/NEMO/TOP_SRC/MEDUSA/zooplankton.F90
===================================================================
--- /branches/UKMO/dev_r5518_GO6_fix_cpp_keys/NEMOGCM/NEMO/TOP_SRC/MEDUSA/zooplankton.F90	(revision 10006)
+++ /branches/UKMO/dev_r5518_GO6_fix_cpp_keys/NEMOGCM/NEMO/TOP_SRC/MEDUSA/zooplankton.F90	(revision 10007)
@@ -42,4 +42,7 @@
                                    zdet, zdtc, zphd, zphn, zzme, zzmi
       USE dom_oce,           ONLY: e3t_0, tmask
+#if defined key_vvl
+      USE dom_oce,           ONLY: e3t_n
+#endif
       USE par_kind,          ONLY: wp
       USE in_out_manager,    ONLY: lwp, numout
Index: /branches/UKMO/dev_r5518_GO6_fix_cpp_keys/NEMOGCM/NEMO/TOP_SRC/trcstat.F90
===================================================================
--- /branches/UKMO/dev_r5518_GO6_fix_cpp_keys/NEMOGCM/NEMO/TOP_SRC/trcstat.F90	(revision 10006)
+++ /branches/UKMO/dev_r5518_GO6_fix_cpp_keys/NEMOGCM/NEMO/TOP_SRC/trcstat.F90	(revision 10007)
@@ -29,4 +29,7 @@
    USE par_trc,           ONLY: jptra
    USE dom_oce,           ONLY: e3t_0, gdepw_0, tmask, e1e2t
+#if defined key_vvl
+   USE dom_oce,           ONLY: e3t_a, e3t_n, gdepw_n
+#endif
    !* MPP library                         
    USE lib_mpp